{
  edition = 201909;

  description = "Genode packages";

  inputs = {
    dhall-haskell.uri =
      "git+https://github.com/dhall-lang/dhall-haskell?ref=flake";
    genode-depot.uri = "git+https://gitea.c3d2.de/ehmry/genode-depot.git";
    genode.uri = "git+https://gitea.c3d2.de/ehmry/genode.git";
    nixpkgs.uri = "git+https://gitea.c3d2.de/ehmry/nixpkgs.git?ref=genode";
  };

  outputs = { self, dhall-haskell, genode-depot, genode, nixpkgs }:
    let
      systems = [ "x86_64-genode" ];

      forAllSystems = f: nixpkgs.lib.genAttrs systems (system: f system);

    in {

      lib = import ./lib {
        genodepkgs = self;
        inherit nixpkgs dhall-haskell genode-depot;
      };

      packages = forAllSystems (system:
        let thisSystem = builtins.getAttr system;
        in import ./packages.nix {
          inherit system nixpkgs;
          depot = thisSystem genode-depot.packages;
          genode = thisSystem genode.packages;
        } // builtins.getAttr system genode.packages);

      checks = forAllSystems (system:
        import ./tests {
          inherit self nixpkgs dhall-haskell genode-depot;
          genodepkgs = builtins.getAttr system self.packages;
        });

    };
}
