# SPDX-FileCopyrightText: Emery Hemingway
#
# SPDX-License-Identifier: LicenseRef-Hippocratic-1.1

{ system, nixpkgs, depot, genode }:

let
  toolchainOverlay = import ./toolchain-overlay;
  # Overlay of toolchain patches

  super = builtins.getAttr system nixpkgs.legacyPackages;

  inherit (super) callPackage;

  dhallPackages = super.dhallPackages // (callPackage ./dhall { });
in rec {
  inherit (super) stdenv;
  libc = callPackage ./pkgs/libc { inherit depot; };
  stdcxx = callPackage ./pkgs/stdcxx { };
  nic_bus = callPackage ./pkgs/nic_bus { inherit (genode) base os; };
  dhallGenode = dhallPackages.genode;
  dhallPrelude = dhallPackages.prelude;
  nova = callPackage ./NOVA { };
  solo5 = callPackage ./pkgs/solo5 { inherit (genode) base os; };
}
